/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of External.xs. Do not edit this file, edit External.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "External.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define SORTEX_UTF8_FLAG    0x1
#define SORTEX_TAINTED_FLAG 0x2

/* Memory requirement for a basic string SV.  The total cost for the SV is 
 * SvLEN(sv) + OVERHEAD.  For SVs which hold more than strings, the overhead
 * will be more, but it's too fiddly, slow, and error-prone to attempt an
 * accurate count.
 */
#define OVERHEAD (sizeof(SV) + sizeof(struct xpv))

typedef struct SortExternal {
    SV     *sortsub;
    SV     *working_dir;
    IV      cache_size;
    IV      mem_threshold;
    SV     *tempfile_fh;    /* Sortfile. */
    PerlIO *fh;
    AV     *item_cache; /* Storage area used by both feed and fetch. */
    AV     *runs;
    IV      mem_bytes;  /* Tally of memory consumed by item_cache. */
    IV      fetch_tick;
} SortExternal;

typedef struct SortExRun {
    SV     *tempfile_fh;
    PerlIO *fh;
    AV     *buffarray;
    Off_t   start;
    Off_t   pos;
    Off_t   end;
} SortExRun;

SortExternal*
SortEx_new(SV *working_dir, SV *sortsub, IV cache_size, IV mem_threshold, 
           SV *tempfile_fh) 
{
    SortExternal *self;
    Newx(self, 1, SortExternal);
    self->working_dir = SvOK(working_dir) ? SvREFCNT_inc(working_dir) : NULL;
    self->sortsub     = SvOK(sortsub )    ? SvREFCNT_inc(sortsub)     : NULL;
    self->cache_size    = cache_size;
    self->mem_threshold = mem_threshold;
    self->tempfile_fh   = newSVsv(tempfile_fh);
    self->fh            = IoIFP( sv_2io(tempfile_fh) );
    self->item_cache    = newAV();
    self->runs          = newAV();
    self->mem_bytes     = 0;
    self->fetch_tick    = 0;

    return self;
}

void
SortEx_destroy(SortExternal *self)
{
    if (self->working_dir) SvREFCNT_dec((SV*)self->working_dir);
    if (self->sortsub)     SvREFCNT_dec((SV*)self->sortsub);
    SvREFCNT_dec(self->tempfile_fh);
    SvREFCNT_dec((SV*)self->item_cache);
    SvREFCNT_dec((SV*)self->runs);
    Safefree(self);
}

SortExRun*
SortExRun_new(SV *tempfile_fh, Off_t start, Off_t end)
{
    SortExRun *self;
    Newx(self, 1, SortExRun);
    self->tempfile_fh  = newSVsv(tempfile_fh);
    self->fh           = IoIFP( sv_2io(self->tempfile_fh) );
    self->buffarray    = newAV();
    self->start        = start;
    self->end          = end;
    self->pos          = start;

    return self;
}

void
SortExRun_destroy(SortExRun *self)
{
    SvREFCNT_dec(self->tempfile_fh);
    SvREFCNT_dec(self->buffarray);
    Safefree(self);
}

/* Take every scalar in the supplied array and print its stringified form to
 * the temporary sortfile, prepending the string length encoded as a
 * compressed integer.
 */
void
SortEx_print_to_sortfile(SortExternal *self, AV *input_av, PerlIO *fh)
{
    int i, max;
    
    for (i = 0, max = av_len(input_av); i <= max; i++) {
        int check; 
        SV **sv_ptr  = av_fetch(input_av, i, 0);

        if (sv_ptr == NULL) {
            continue;
        }
        else {
            SV         *scratch_sv  = *sv_ptr;
            STRLEN      len;
            char       *string      = SvPV(scratch_sv, len);
            UV          aUV         = len;
            int         type        = SvTYPE(scratch_sv);
            char        flags       = 0;
            char        num_buf[5];
            char *const buf_end     = num_buf + 5;
            char       *encoded_len = buf_end;

            /* Throw an error if the item isn't a plain old scalar. */
            if (type > SVt_PVMG || type == SVt_RV) {
                croak("can't handle anything other than plain scalars");
            }
            
            /* Encode length of scalar as a BER compressed integer. */
            do {
                *--encoded_len = (char)((aUV & 0x7f) | 0x80);
                aUV >>= 7;
            } while (aUV);
            *(buf_end - 1) &= 0x7f;  

            /* Record utf8 and taint status. */
            if (SvUTF8(scratch_sv))    flags |= SORTEX_UTF8_FLAG;
            if (SvTAINTED(scratch_sv)) flags |= SORTEX_TAINTED_FLAG;

            /* Print len, string, and flags. */
            check = PerlIO_write(fh, encoded_len, (buf_end - encoded_len));
            if (check < 0) croak("PerlIO error: errno %d", errno);
            check = PerlIO_write(fh, string, len);
            if (check != (int)len) {
                croak("PerlIO error: tried to write %"UVuf" bytes, wrote %d",
                    (UV)len, check);
            }
            check = PerlIO_write(fh, &flags, 1);
            if (check != 1) croak("PerlIO error: errno %d", errno);
        }
    }
}

/* Recover items from disk.
 */
IV
SortExRun_refill_buffer(SortExRun *self)
{
    /* Extract filehandle and buffer array from object. */   
    PerlIO *const  fh           = self->fh;
    AV *const      buffarray_av = self->buffarray;
    int            num_items    = 0;
    Off_t          limit        = self->end - self->pos < 32768
                                ? self->end
                                : self->pos + 32768;

    PerlIO_seek(fh, self->pos, 0);
    while (self->pos < limit) {
        UV  item_length = 0;
        int check;

        /* Retrieve and decode len. */
        while (1) {
            U8 digit;
            check = PerlIO_read(fh, (char*)&digit, 1);
            self->pos++;
            if (check < 0) croak("PerlIO failed: %s", strerror(errno));
            item_length = (item_length << 7) | (digit & 0x7f);
            if (digit < 0x80) break; 
        }

        {
            /* Recover the stringified scalar from disk. */
            SV   *item_sv = newSV(item_length + 1);
            char  flags;

            SvCUR_set(item_sv, item_length);
            SvPOK_on(item_sv);
            check = PerlIO_read(fh, SvPVX(item_sv), item_length);
            if (check < (int)item_length) {
                croak("PerlIO error: read %d bytes, expected %"UVuf" bytes", 
                    check, (UV)item_length);
            }
            self->pos += check;
            *(SvEND(item_sv)) = '\0'; /* Null-terminate. */

            /* Restore UTF8 and taint flags. */
            check = PerlIO_read(fh, &flags, 1);
            self->pos++;
            if (check < 1) croak("PerlIO failed: %s", strerror(errno));
            if (flags & SORTEX_UTF8_FLAG)    SvUTF8_on(item_sv);
            if (flags & SORTEX_TAINTED_FLAG) SvTAINTED_on(item_sv);

            /* Add to the buffarray. */
            av_push(buffarray_av, item_sv);

            /* Track how much we've read so far. */
            num_items++;
        }
    }

    return num_items;
}

#line 221 "External.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 365 "External.c"

XS_EUPXS(XS_Sort__External__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__new)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "class_name, working_dir, sortsub, cache_size, mem_threshold, tempfile_fh");
    {
	char *	class_name = (char *)SvPV_nolen(ST(0))
;
	SV *	working_dir = ST(1)
;
	SV *	sortsub = ST(2)
;
	IV	cache_size = (IV)SvIV(ST(3))
;
	IV	mem_threshold = (IV)SvIV(ST(4))
;
	SV *	tempfile_fh = ST(5)
;
	SV *	RETVAL;
#line 224 "External.xs"
{
    SortExternal *self = SortEx_new(working_dir, sortsub, cache_size, 
        mem_threshold, tempfile_fh);
    RETVAL = newSV(0);
    sv_setref_pv(RETVAL, class_name, (void*)self);
}
#line 394 "External.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sort__External_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 236 "External.xs"
    SortEx_destroy(self);
#line 422 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External_feed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External_feed)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 242 "External.xs"
{
    AV *const item_cache = self->item_cache;
    I32 start    = av_len(item_cache) + 1;
    I32 new_size = start + items - 1;
    IV  space    = (OVERHEAD + sizeof(SV*)) * (items - 1);
    I32 i;
    int need_to_flush = 0;

    /* Push arguments onto cache array. */
    av_extend(self->item_cache, new_size);
    for (i = 1; i < items; i++) {
        SV *const element = ST(i);
        SV *const copy    = newSVsv(element);
        av_push(item_cache, copy);

        /* Calculate a rough estimate of the memory occupied by the arguments:
         * sum the allocated string lengths, plus 15 bytes per scalar as
         * overhead.  Also, sv_len() has a side-effect of stringifying the SV.
         */
        space += sv_len(copy);
    }
    self->mem_bytes += space;

    if (self->cache_size > 0) {
        /* Use the number of cache elements as a flush-trigger. */
        if (av_len(self->item_cache) + 1 >= self->cache_size) 
            need_to_flush = 1;
    }
    else if (self->mem_bytes > self->mem_threshold) {
        /* Use memory consumption as a flush-trigger. */
        need_to_flush = 1;
    }
    if (need_to_flush) {
        ENTER;
        SAVETMPS;
        PUSHMARK(SP);
        XPUSHs( ST(0) );
        call_method("_write_item_cache_to_tempfile", G_VOID|G_DISCARD);
        PUTBACK;
        FREETMPS;
        LEAVE;
    }
}
#line 491 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External_fetch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External_fetch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 290 "External.xs"
{
    if (self->fetch_tick > av_len(self->item_cache)) {
        ENTER;
        SAVETMPS;
        PUSHMARK(SP);
        XPUSHs( ST(0) );
        call_method("_gatekeeper", G_VOID|G_DISCARD);
        PUTBACK;
        FREETMPS;
        LEAVE;
    }

    if (self->fetch_tick > av_len(self->item_cache)) {
        /* If empty, return false in both scalar and list context. */
        XSRETURN(0);
    }
    else {
        SV *elem = av_delete(self->item_cache, self->fetch_tick, 0);
        self->fetch_tick++;
        ST(0) = elem;
        XSRETURN(1);
    }
}
#line 540 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__get_something); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__get_something)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SortExternal *	self;
	SV *	RETVAL;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 324 "External.xs"
{
    switch(ix) {
        case 1: RETVAL = self->sortsub 
                       ? newSVsv(self->sortsub) 
                       : newSV(0);
                break;

        case 2: RETVAL = newRV_inc((SV*)self->item_cache);
                break;

        case 3: RETVAL = newRV_inc((SV*)self->runs);
                break;

        case 4: RETVAL = newSVsv(self->tempfile_fh);
                break;

        case 5: RETVAL = newSVsv(self->working_dir);
                break;

        default:
            croak("unrecognized alias number %d", ix);
    }
}
#line 589 "External.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sort__External__set_mem_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__set_mem_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, mem_bytes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;
	IV	mem_bytes = (IV)SvIV(ST(1))
;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 354 "External.xs"
    self->mem_bytes = mem_bytes;
#line 619 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__set_fetch_tick); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__set_fetch_tick)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, fetch_tick");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;
	IV	fetch_tick = (IV)SvIV(ST(1))
;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 361 "External.xs"
    self->fetch_tick = fetch_tick;
#line 648 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__set_temp_fh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__set_temp_fh)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, tempfile_fh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;
	SV *	tempfile_fh = ST(1)
;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;
#line 368 "External.xs"
    SvREFCNT_dec(self->tempfile_fh);
    self->tempfile_fh   = newSVsv(tempfile_fh);
    self->fh            = IoIFP( sv_2io(tempfile_fh) );
#line 679 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__print_to_sortfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__print_to_sortfile)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, input_av, fh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExternal *	self;
	AV *	input_av;
	PerlIO *	fh = IoIFP(sv_2io(ST(2)))
;

    if (sv_derived_from(ST(0), "Sort::External")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExternal*,tmp);
    }
    else
        croak("Not a Sort::External")
;

    if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVAV)
        input_av = (AV*)SvRV(ST(1));
    else
        Perl_croak(aTHX_ "input_av is not an array reference")
;
#line 378 "External.xs"
    SortEx_print_to_sortfile(self, input_av, fh);
#line 715 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__utf8_on); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__utf8_on)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 384 "External.xs"
    /* Testing only. */
    SvUTF8_on(sv);
#line 736 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__SortExRun__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__SortExRun__new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "class_sv, tempfile_fh, start, end");
    {
	SV *	class_sv = ST(0)
;
	SV *	tempfile_fh = ST(1)
;
	NV	start = (NV)SvNV(ST(2))
;
	NV	end = (NV)SvNV(ST(3))
;
	SortExRun *	RETVAL;
#line 396 "External.xs"
    RETVAL = SortExRun_new(tempfile_fh, start, end);
    (void)class_sv; /* Silence "unused var" compiler warning. */
#line 762 "External.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Sort::External::SortExRun", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sort__External__SortExRun_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__SortExRun_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExRun *	self;

    if (sv_derived_from(ST(0), "Sort::External::SortExRun")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExRun*,tmp);
    }
    else
        croak("Not a Sort::External::SortExRun")
;
#line 404 "External.xs"
    SortExRun_destroy(self);
#line 794 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__SortExRun__get_buffarray); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__SortExRun__get_buffarray)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SortExRun *	self;
	SV *	RETVAL;

    if (sv_derived_from(ST(0), "Sort::External::SortExRun")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExRun*,tmp);
    }
    else
        croak("Not a Sort::External::SortExRun")
;
#line 410 "External.xs"
    RETVAL = newRV_inc((SV*)self->buffarray);
#line 820 "External.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sort__External__SortExRun__set_buffarray); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__SortExRun__set_buffarray)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, buffarray");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SortExRun *	self;
	AV *	buffarray;

    if (sv_derived_from(ST(0), "Sort::External::SortExRun")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExRun*,tmp);
    }
    else
        croak("Not a Sort::External::SortExRun")
;

    if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVAV)
        buffarray = (AV*)SvRV(ST(1));
    else
        Perl_croak(aTHX_ "buffarray is not an array reference")
;
#line 418 "External.xs"
    SvREFCNT_dec((SV*)self->buffarray);
    self->buffarray = (AV*)SvREFCNT_inc((SV*)buffarray);
#line 856 "External.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sort__External__SortExRun__refill_buffer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sort__External__SortExRun__refill_buffer)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SortExRun *	self;
	IV	RETVAL;
	dXSTARG;

    if (sv_derived_from(ST(0), "Sort::External::SortExRun")) {
        IV tmp = SvIV((SV*)SvRV(ST(0)));
        self = INT2PTR(SortExRun*,tmp);
    }
    else
        croak("Not a Sort::External::SortExRun")
;
#line 425 "External.xs"
    RETVAL = SortExRun_refill_buffer(self);
#line 883 "External.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Sort__External); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sort__External)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Sort::External::_new", XS_Sort__External__new);
        newXS_deffile("Sort::External::DESTROY", XS_Sort__External_DESTROY);
        newXS_deffile("Sort::External::feed", XS_Sort__External_feed);
        newXS_deffile("Sort::External::fetch", XS_Sort__External_fetch);
        cv = newXS_deffile("Sort::External::_get_item_cache", XS_Sort__External__get_something);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Sort::External::_get_runs", XS_Sort__External__get_something);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Sort::External::_get_something", XS_Sort__External__get_something);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Sort::External::_get_sortsub", XS_Sort__External__get_something);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Sort::External::_get_tempfile_fh", XS_Sort__External__get_something);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Sort::External::_get_working_dir", XS_Sort__External__get_something);
        XSANY.any_i32 = 5;
        newXS_deffile("Sort::External::_set_mem_bytes", XS_Sort__External__set_mem_bytes);
        newXS_deffile("Sort::External::_set_fetch_tick", XS_Sort__External__set_fetch_tick);
        newXS_deffile("Sort::External::_set_temp_fh", XS_Sort__External__set_temp_fh);
        newXS_deffile("Sort::External::_print_to_sortfile", XS_Sort__External__print_to_sortfile);
        newXS_deffile("Sort::External::_utf8_on", XS_Sort__External__utf8_on);
        newXS_deffile("Sort::External::SortExRun::_new", XS_Sort__External__SortExRun__new);
        newXS_deffile("Sort::External::SortExRun::DESTROY", XS_Sort__External__SortExRun_DESTROY);
        newXS_deffile("Sort::External::SortExRun::_get_buffarray", XS_Sort__External__SortExRun__get_buffarray);
        newXS_deffile("Sort::External::SortExRun::_set_buffarray", XS_Sort__External__SortExRun__set_buffarray);
        newXS_deffile("Sort::External::SortExRun::_refill_buffer", XS_Sort__External__SortExRun__refill_buffer);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

